import java.io.FileNotFoundException;

public class Main {
    public static char getBestChoice(QuadGramLikelihoods likelihoods, String before, String after) {
        char bestLetter = '?';
        double best = Double.NEGATIVE_INFINITY;
        /*
        char bestLetter = 'A';
        double best = likelihoods.get(before + 'A' + after);
        */
        for (char letter = 'A'; letter <= 'Z'; letter++) {
            String quadgram = before + letter + after;
            if (likelihoods.get(quadgram) > best) {
                bestLetter = letter;
                best = likelihoods.get(quadgram);
            }
        }
        return bestLetter;
        // for every letter in the alphabet,
            // combine before + L + after
            // ask for for likelihood of that combo
            // keep a running "maximum" letter
    }

    private static final int N = 4;

    public static String[] deduceHiddenLetter(QuadGramLikelihoods likelihoods, String hidden) {
        String[] results = new String[N];
        int qmark = hidden.indexOf('?');
        for (int i = 0; i < N; i++) {
            String before = hidden.substring(qmark - i, qmark);
            String after = hidden.substring(qmark + 1, qmark - i + N);
            System.out.println(before + "?" + after);
            char best = getBestChoice(likelihoods, before, after);
            results[i] = hidden.substring(0, qmark) +
                    best +
                    hidden.substring(qmark + 1, hidden.length());
        }
        return results;
    }

    public static void main(String[] args) throws FileNotFoundException {
        QuadGramLikelihoods likelihoods = new QuadGramLikelihoods();

        String hidden = "PSYC?OLOGY";
        //SYC? or YC?O ...
        String[] deduced = deduceHiddenLetter(likelihoods, hidden);
        for (int i = 0; i < deduced.length; i++) {
            System.out.println(hidden + " -> " + deduced[i]);
        }
    }
}
