import org.junit.jupiter.api.*;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import java.io.FileNotFoundException;

import static org.junit.jupiter.api.Assertions.*;


public class Tests {
    @Order(0)
    @DisplayName("Test deduceHiddenLetter")
    @ParameterizedTest
    @CsvSource({
            "?SYCHOLOGY,,,,PSYCHOLOGY",
            "P?YCHOLOGY,,,PSYCHOLOGY,PSYCHOLOGY",
            "PS?CHOLOGY,,PSYCHOLOGY, PSUCHOLOGY, PSSCHOLOGY",
            "PSY?HOLOGY,PSYCHOLOGY, PSYCHOLOGY, PSYSHOLOGY, PSYWHOLOGY",
            "PSYC?OLOGY,PSYCHOLOGY, PSYCHOLOGY, PSYCHOLOGY, PSYCCOLOGY",
            "PSYCH?LOGY,PSYCHALOGY, PSYCHILOGY, PSYCHELOGY, PSYCHOLOGY",
            "PSYCHO?OGY,PSYCHOOOGY, PSYCHOTOGY, PSYCHOLOGY, PSYCHOLOGY",
            "PSYCHOL?GY,PSYCHOLDGY, PSYCHOLOGY, PSYCHOLOGY,",
            "PSYCHOLO?Y,PSYCHOLOGY, PSYCHOLOGY,,",
            "PSYCHOLOG?,PSYCHOLOGY,,,",
            "PSYCHOLOGY,PSYCHOLOGY,PSYCHOLOGY,PSYCHOLOGY,PSYCHOLOGY",
    })
    public void testDeduceHiddenLetter(String hidden, String correct0, String correct1, String correct2, String correct3) throws FileNotFoundException {
        QuadGramLikelihoods likelihoods = new QuadGramLikelihoods();
        String[] correct = {correct0, correct1, correct2, correct3};

        String[] deduced = Main.deduceHiddenLetter(likelihoods, hidden);
        assertArrayEquals(correct, deduced);

    }
}
